=== debian/changelog ===
ros-galactic-rclpy (1.9.3-1focal) focal; urgency=high

  * remove feedback callback when the goal has been completed. (#932 <https://github.com/ros2/rclpy/issues/932>)
  * Waitable should check callback_group if it can be executed. (#1014 <https://github.com/ros2/rclpy/issues/1014>)
  * support wildcard matching for params file (#1003 <https://github.com/ros2/rclpy/issues/1003>)
  * Contributors: Chen Lihui, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 06 Dec 2022 08:00:00 -0000

ros-galactic-rclpy (1.9.2-1focal) focal; urgency=high

  * Bugfix/duration to msg precision (#876 <https://github.com/ros2/rclpy/issues/876>) (#916 <https://github.com/ros2/rclpy/issues/916>)
  * Avoid exception in Node constructor when use override for 'use_sim_time' (#896 <https://github.com/ros2/rclpy/issues/896>) (#913 <https://github.com/ros2/rclpy/issues/913>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 30 Jun 2022 07:00:00 -0000

ros-galactic-rclpy (1.9.1-1focal) focal; urgency=high

  * Remove -> bool annotation for destroy_node #886 <https://github.com/ros2/rclpy/issues/886> (#891 <https://github.com/ros2/rclpy/issues/891>)
  * Fix memory leak. (#840 <https://github.com/ros2/rclpy/issues/840>)
  * Fix automatically declared parameters descriptor type. (backport #853 <https://github.com/ros2/rclpy/issues/853>) (#854 <https://github.com/ros2/rclpy/issues/854>)
  * Only add one done callback to a future (#816 <https://github.com/ros2/rclpy/issues/816>) (#821 <https://github.com/ros2/rclpy/issues/821>)
  * Remove unused function make_mock_subscription (#809 <https://github.com/ros2/rclpy/issues/809>) (#810 <https://github.com/ros2/rclpy/issues/810>)
  * Convert Node and Context to use C++ Classes (#771 <https://github.com/ros2/rclpy/issues/771>)
  * Pybind11 actionserver nitpicks and docblock improvements (#774 <https://github.com/ros2/rclpy/issues/774>)
  * Pybind11 action goal handle nitpicks (#767 <https://github.com/ros2/rclpy/issues/767>)
  * Convert Guardcondition to use C++ classes (#772 <https://github.com/ros2/rclpy/issues/772>)
  * Removed unused structs (#770 <https://github.com/ros2/rclpy/issues/770>)
  * Convert WaitSet to use C++ Classes (#769 <https://github.com/ros2/rclpy/issues/769>)
  * Convert ActionServer to use C++ Classes (#766 <https://github.com/ros2/rclpy/issues/766>)
  * Convert ActionClient to use C++ classes (#759 <https://github.com/ros2/rclpy/issues/759>)
  * Use py::class_ for rcl_action_goal_handle_t (#751 <https://github.com/ros2/rclpy/issues/751>)
  * Convert Publisher and Subscription to use C++ Classes (#756 <https://github.com/ros2/rclpy/issues/756>)
  * Contributors: Alejandro Hernández Cordero, Greg Balke, Shane Loretz, Suraj Pattar, mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 28 Apr 2022 07:00:00 -0000

ros-galactic-rclpy (1.9.0-1focal) focal; urgency=high

  * Allow declaring uninitialized statically typed parameters. (#798 <https://github.com/ros2/rclpy/issues/798>) (#799 <https://github.com/ros2/rclpy/issues/799>)
  * Reject cancel request if failed to transit to CANCEL_GOAL state. (#791 <https://github.com/ros2/rclpy/issues/791>) (#795 <https://github.com/ros2/rclpy/issues/795>)
  * Contributors: Jacob Perron, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 20 May 2021 07:00:00 -0000

ros-galactic-rclpy (1.8.2-1focal) focal; urgency=high

  * Break log function execution ASAP if configured severity is too high (#776 <https://github.com/ros2/rclpy/issues/776>) (#783 <https://github.com/ros2/rclpy/issues/783>)
  * Contributors: ksuszka

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 10 May 2021 07:00:00 -0000

ros-galactic-rclpy (1.8.1-1focal) focal; urgency=high

  * typo fix. (#768 <https://github.com/ros2/rclpy/issues/768>)
  * Restore exceptions for Connext and message timestamps on Windows (#765 <https://github.com/ros2/rclpy/issues/765>)
  * Use correct type when creating test publisher (#764 <https://github.com/ros2/rclpy/issues/764>)
  * Add a test for destroy_node while spinning (#663 <https://github.com/ros2/rclpy/issues/663>)
  * Add __enter__ and __exit__ to Waitable (#761 <https://github.com/ros2/rclpy/issues/761>)
  * Check if shutdown callback weak method is valid before calling it (#754 <https://github.com/ros2/rclpy/issues/754>)
  * Contributors: Andrea Sorbini, Ivan Santiago Paunovic, Scott K Logan, Shane Loretz, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 12 Apr 2021 07:00:00 -0000

ros-galactic-rclpy (1.8.0-1focal) focal; urgency=high

  * Change index.ros.org -> docs.ros.org. (#755 <https://github.com/ros2/rclpy/issues/755>)
  * Use py::class_ for rcl_event_t (#750 <https://github.com/ros2/rclpy/issues/750>)
  * Convert Clock to use a C++ Class (#749 <https://github.com/ros2/rclpy/issues/749>)
  * Convert Service to use C++ Class (#747 <https://github.com/ros2/rclpy/issues/747>)
  * Fix windows warning by using consistent types (#753 <https://github.com/ros2/rclpy/issues/753>)
  * Use py::class_ for rmw_service_info_t and rmw_request_id_t (#748 <https://github.com/ros2/rclpy/issues/748>)
  * Convert Timer to use a C++ Class (#745 <https://github.com/ros2/rclpy/issues/745>)
  * Add PythonAllocator (#746 <https://github.com/ros2/rclpy/issues/746>)
  * Use py::class_ for rmw_qos_profile_t (#741 <https://github.com/ros2/rclpy/issues/741>)
  * Combine pybind11 modules into one (#743 <https://github.com/ros2/rclpy/issues/743>)
  * Use py::class_ for rcl_duration_t (#744 <https://github.com/ros2/rclpy/issues/744>)
  * Fix bug in unique_ptr type argument (#742 <https://github.com/ros2/rclpy/issues/742>)
  * Convert Client to use C++ Class (#739 <https://github.com/ros2/rclpy/issues/739>)
  * Converting last of _rclpy.c to pybind11 (#738 <https://github.com/ros2/rclpy/issues/738>)
  * Make sure only non-empty std::vector of arguments are indexed (#740 <https://github.com/ros2/rclpy/issues/740>)

